;;;-*-Mode: LISP; Package: DM -*-
;;
;; **********************************
;;   loading and setting the system 
;; **********************************

(in-package :dm)

;; =============================
;; global dm system variables
;; =============================

(defvar *demo-version* nil)
(setq *demo-version* nil) ; *********** set t if making standalone *******
(defvar *coda-demo-version* nil)
(setq *coda-demo-version* nil)
(defvar *dm-def-files* nil)

;; =============================
;; global dm variables
;; =============================

(defvar *env-settings*) ;default environment variables object
(defvar *active-score*)  ;default score




;; =============================
;;   LOAD UTILITIES AND STUFFS
;; =============================
;;
;; AGNULA: (load "dm:lib;platform-dependencies.lsp")
;; AGNULA: (set-platform-dependant-variables-PD)   ; before load-utilities-PD !
(load "dm:lib;read-and-compile.lsp")
(load "dm:lib;dm-objects.lsp")
(setq *env-settings* (make-instance 'environment-settings))  ;*********** save/load status

;;#+:mswindows ;this will start the file dialogs in the same folder as the program
(when *demo-version*
   (set-dm-var 'lib-directory nil)
   (set-dm-var 'rules-directory nil)
   (set-dm-var 'rule-sets-directory nil)
   (set-dm-var 'music-directory nil)
   (set-dm-var 'log-directory nil)
   (set-dm-var 'current-music-directory nil)
   (set-dm-var 'current-rule-sets-directory nil)
   )

;; ==================
;;  LOAD THE SYSTEM
;; ==================
;;
;; for many of the old Mac "lib" files, an ACL Win95 version is provided when
;; dependant on the platform because of graphic, interface and midishare commands.
;;
(setf *dm-def-files*
      '(    ; the list of all files in dm
        "dm:lib;infixmath.lsp"
        "dm:lib;basicmacros.lsp"
        "dm:lib;scoreobjects.lsp"
        "dm:lib;shapeobjects.lsp"
        "dm:lib;syntobjects.lsp"
        "dm:lib;rule-dialog-common.lsp"
        "dm:lib;rulemacros.lsp"
        "dm:lib;parallelrulemacros.lsp"
        "dm:lib;initconvert.lsp"
        "dm:lib;musicio.lsp"
	"dm:lib;midifileinput.lsp"
	"dm:lib;midifileoutput.lsp"
	"dm:lib;midibasic-win.lsp"
        "dm:lib;utilityrules.lsp"

	"dm:rules;frules1.lsp"
        "dm:rules;frules2.lsp"
        "dm:rules;synconmel.lsp"
        "dm:rules;intonation.lsp"
        "dm:rules;punctuation.lsp"
        "dm:rules;swing.lsp"
        "dm:rules;phrasearch.lsp"
        "dm:rules;finalritard.lsp"
        "dm:rules;noise.lsp"
        "dm:rules;articulation.lsp"

        "dm:lib;rule-groups.lsp"
        "dm:lib;playlist.lsp"
        ))





(dolist (file *dm-def-files*)  ;load the system
  (load file))




;eof





