;; Copyright (c) 2004 Lars Frydn, Johan Sundberg, Anders Friberg, Roberto Bresin
;; For information on usage and redistribution, and for a DISCLAIMER OF ALL
;; WARRANTIES, see the files, "README.txt" and "DIRECTORMUSICES.LICENSE.txt", in this distribution.


;;
;; ***********************************************
;;   This file is the loader for Director Musices
;; ***********************************************
;;
;; 2003.12 /rb created

 
;(defpackage :dm
;	(:use :common-lisp-user :common-lisp))

(in-package :dm)


;(defun translate-logical-pathnames-PD ()
;  (setf (logical-pathname-translations "dm") `(("**;*.*.*" "//home//robmod//dm//**//*.*"))))


;(translate-logical-pathnames-PD)

;(load ".//lib//make-dm2-cmulisp-linux.lsp")



;(in-package "DM")

(defun dm-loop()
 (setf choice 'c)
  (loop until (eq choice 'q) do
	(format t "

	The Director Musices choice menu:

	[1] Load score file .MUS
	[2] Load score file .MID
	[3] Load rules file .PAL
	[4] Save score file .MUS
	[5] Save dead-pan file .MID
	[6] Save performed file .PER
	[7] Save performed file .MID (SMF0)
	[8] Save performed file .MID (SMF1)
	[9] Play MIDI file
	[Q] Quit!

	==> ")
	(setf choice (read))

	(case choice
		((1)
			(format t "	Write the imput score file name [.MUS], using the form \"FILENAME\": ")
			(setf inputscoreMUS (read-line))

			;; read score in .MUS format
			(read-active-score-from-file inputscoreMUS)
			(init-music))
		((2)
			(format t "	Write the input score file name [.MID], using the form \"FILENAME\": ")
			(setf inputscoreMID (read-line))

			;; read score in .MID format
			(load-midifile-fpath inputscoreMID)
			(init-music))
		((3)
			(format t "	Write the rule palette file name [.PAL], using the form \"FILENAME\": ")
			(setf inputrulepalettePAL (read-line))

			;;open a rule palette
			(load inputrulepalettePAL)

			;;apply the rule palette with melodic sync
			(apply-rule-list-simple-mel-sync (get-dm-var 'all-rules)))

		((4)
			(format t "	Write the score file name [.MUS], using the form \"FILENAME\": ")
			(setf saveSCORE (read-line))

			;;save score file
			(save-score-fpath saveSCORE))


		((5)
			(format t "	Write the dead-pan file name [.MID], using the form \"FILENAME\": ")
			(setf saveDEADPAN (read-line))

			;;save dead-pan performance
			(init-music-mf)
			;(reset-music)
			(save-performance-midifile1-fpath saveDEADPAN))

		((6)
			(format t "	Write the performed file name [.PER], using the form \"FILENAME\": ")
			(setf performedPER (read-line))

			;;save performance
			(save-performance-fpath performedPER))

		((7)
			(format t "	Write the performed file name [.MID], SMF0, using the form \"FILENAME\": ")
			(setf performedMID0 (read-line))

			;;save midi file type 0
			(save-performance-midifile0-fpath performedMID0))

		((8)
			(format t "	Write the performed file name [.MID], SMF1, using the form \"FILENAME\": ")
			(setf performedMID1 (read-line))

			;;save midi file type 1
			(save-performance-midifile1-fpath performedMID1))

		((9)
			(format t "	Write the name of the MIDI file to be played [.MID], using the form \"FILENAME\": ")
			(setf playMIDI (read-line))

			;;play MIDI file with kmidi
			#+cmu (extensions:run-program "timidity" (list "-iatv" playMIDI) :wait nil)
			#+sbcl (sb-ext:run-program "timidity" (list "-iatv" playMIDI) :wait nil)
			#+allegro (excl:run-shell-command (concatenate 'string "mplayer2 " playMIDI) :wait nil)
			)
			)
	))


(dm-loop)





